package pack_wanderer_command;

import java.util.Iterator;
import java.util.Stack;

public class Invoker {

	Stack<Command> undoStack = new Stack<Command>();
	Stack<Command> redoStack = new Stack<Command>();

	public void store(Command commandObject) throws CommandException {
		commandObject.execute();
		this.undoStack.push(commandObject); // push only if no exception raised
		this.redoStack.clear();
	}

	public void undo()	{
		if(!undoStack.empty()) {
			Command command = undoStack.pop();
			command.undo();
			redoStack.push(command);
		}
	}

	public void redo()	{
		if(!redoStack.empty()) {
			Command command = redoStack.pop();
			try {command.execute();} catch (Exception e) {e.printStackTrace();} //cannot fail
			undoStack.push(command);
		}
	}

	public String commandsToString() {
		String commands= "";
		for (Iterator it = undoStack.iterator(); it.hasNext();) {
			Command command = (Command) it.next();
			commands += command.toString()+"\n";
		}
		return commands;
	}
}
